// Class  : ChatListener, NewChatServer
// Author : Russ Ethington
// Version: 2/16/96 for Java 1.0

import java.io.*;
import java.net.*;
import java.lang.*;

class ChatListener
{
   public static void main(String args[])
   {
      try
         {new NewChatServer().start();}
      catch (Exception error)
         {System.out.println("Could not start listener server:" + error);}
   }
}

class NewChatServer extends SimpleServerConnection
{
   public void start()
   {
      System.out.println("Accepting calls...");
      super.start(4646);
   }

   public void handleSession(DataInputStream in, PrintStream out)
   {
      String who;
      String where;
      String incoming;

      try
      {
         who = in.readLine();
         where = in.readLine();
      } 
      catch (IOException e)
      {
         System.out.println("Could not read line from client.");
         return;
      }

      System.out.println(who + " has connected from " + where + ".");

      try
      {
         while ((incoming = in.readLine()) != null)
         {
            System.out.print(who);
            for (int i = who.length(); i < 10; i++) System.out.print(" ");
            System.out.println(": " + incoming);
         }
      }
      catch (IOException e) { }

      System.out.println(who + " has disconnected.");
   }
}
